function Sprite:CompareDepthTo(cmp)
	if cmp == self then return 0 end
	
	p1 = self:getParent()
	p2 = cmp:getParent()
	if p1 == cmp then --cmp is parent of self
		return 1 
	
	elseif self == p2 then --self is parent of cmp
		return -1 
	
	elseif p1 == p2 and p1 ~= nil then -- the same root
		return p1:getChildIndex(self) > p1:getChildIndex(cmp) and 1 or -1
	
	else --complicate relationship
		local p1 = self
		local p2 = cmp
		local pp1 = {}
		local pp2 = {}
		while p1 ~= nil do
			pp1[#pp1 + 1] = p1
			p1 = p1:getParent()
		end
		while p2 ~= nil do
			pp2[#pp2 + 1] = p2
			p2 = p2:getParent()
		end
		
		local m = math.min(#pp2, #pp1)
		local index = 0
		
		for i = 0, m - 1 do
			index = i
			if pp2[#pp2 - i] ~= pp1[#pp1 - i] then break end
		end
		
		if index == 0 then -- not the same root
			return nil
		elseif index == m - 1 then -- one of them are parent/root of other, for ex: [19 17 15 4 2 1] <-> [15 4 2 1]
			return #pp1 > #pp2 and 1 or -1
		else
			local common_p = pp1[#pp1 - index + 1]
			local child1 = pp1[#pp1 - index]
			local child2 = pp2[#pp2 - index]
			return common_p:getChildIndex(child1) > common_p:getChildIndex(child2) and 1 or -1
		end
	end
end


local spr = {}
for i=1, 21 do 
	local n = #spr + 1
	spr[n] = Sprite.new() 
	spr[n].id = i
end

local tree = {
	[1] = {2, 6},
	[2] = {3, 4, 5},
	[3] = {13, 14},
	[4] = {15},
	[5] = {12},
	[6] = {7, 8},
	[7] = {9, 10},
	[8] = {11},
	[9] = {},
	[10]= {},
	[11]= {20},
	[12]= {},
	[13]= {},
	[14]= {},
	[15]= {16, 17},
	[16]= {},
	[17]= {18},
	[18]= {},
	[19]= {},
	[20]= {},
	[21]= {},
}

for k,v in pairs(tree) do
	for _, v2 in pairs(v) do
		spr[k]:addChild(spr[v2])
	end
end
stage.id = "state"
stage:addChild(spr[1])

local testbed = {
	{12, 12},
	{15, 12},
	{12, 15},
	{16, 17},
	{16, 4},
	{16, 15},
	{21, 18}
}
for k,v in pairs(testbed) do
	local p1, p2 = v[1], v[2]
	print(p1, p2, spr[p1]:CompareDepthTo(spr[p2]))
end
